/*
 * Axis.java
 *
 * Created on 24  2003 ., 15:52
 */

package com.fn.repway;


import org.w3c.dom.Element;


/**
 *
 * @author  asso
 */
public class Axis {
    
    private boolean autoCalcMin;
    private double minValue;
    private boolean autoCalcMax;
    private double maxValue;
    private double tickInterval;
    private boolean minMaxNotAvail;
    private int maxTicks;
    
    /** Creates a new instance of Axis */
    public Axis(Element tag) {
        if (tag == null) {
            autoCalcMin = true;
            autoCalcMax = true;
            tickInterval = 0.0;
            minMaxNotAvail = true;
            maxTicks = -1;
        } else {
            String str = XMLUtils.getAttrib(tag, "min", "auto");
            if (str.equals("auto")) {
                autoCalcMin = true;
                minMaxNotAvail = true;
            } else {
                autoCalcMin = false;
                minValue = XMLUtils.getAttrib(tag, "min", 0.0);
            }

            str = XMLUtils.getAttrib(tag, "max", "auto");
            if (str.equals("auto")) {
                autoCalcMax = true;
                minMaxNotAvail = true;
            } else {
                autoCalcMax = false;
                maxValue = XMLUtils.getAttrib(tag, "max", 100.0);
            }

            tickInterval = XMLUtils.getAttrib(tag, "ticks", 0.0);
            maxTicks = XMLUtils.getAttrib(tag, "maxTicks", -1);
        }
    }
    
    public void updateMinMax(double value) {
        if (minMaxNotAvail) {
            if (autoCalcMin) minValue = value;
            if (autoCalcMax) maxValue = value;
            minMaxNotAvail = false;
        }
        if (autoCalcMin && (value < minValue)) minValue = value;
        if (autoCalcMax && (value > maxValue)) maxValue = value;
    }
    
    public double getMinValue() {
        return minValue;
    }
    
    public double getMaxValue() {
        return maxValue;
    }
    
    public double getTickInterval() {
        if (maxTicks == -1)
            return tickInterval;
        else {
            int ticksCnt = (int)(maxValue / tickInterval);
            if (ticksCnt > maxTicks) {
                double ni = tickInterval * 2;
                while (((int)(maxValue / ni)) > maxTicks)
                    ni += tickInterval;
                return ni;
            } else
                return tickInterval;
        }
    }
}
