/*
 * CompBar.java
 *
 * Created on 6  2003 ., 15:16
 */

package com.fn.repway;


import java.awt.Color;
import java.awt.BasicStroke;
import java.awt.Stroke;
import java.awt.Rectangle;
import org.w3c.dom.Element;


/**
 *
 * @author  asso
 */
public class CompBar extends Primitive {
    
    private Color frameColor;
    private Color fillColor;
    private double thickness;

    /** Creates a new instance of CompBar */
    public CompBar(double x, double y, double width, double height, double thickness,
            Color frameColor, Color fillColor) 
    {
        super(x, y, width, height);
        this.frameColor = frameColor;
        this.fillColor = fillColor;
        this.thickness = thickness;
    }
    
    public CompBar(Element tag) throws RepException {
        super(tag);
        frameColor = XMLUtils.getColorAttrib(tag, "frameColor", "#000000");
        fillColor = XMLUtils.getColorAttrib(tag, "fillColor", "#FFFFFF");
        thickness = XMLUtils.getAttrib(tag, "thickness", 1.0);
    }
    
    void draw(java.awt.Graphics2D g2) {
        Stroke s = new BasicStroke((float)thickness);
        Stroke oldStroke = g2.getStroke();
        g2.setStroke(s);
        g2.setColor(fillColor);
        g2.fill(new Rectangle.Double(left, top, width, height));
        g2.setColor(frameColor);
        g2.draw(new Rectangle.Double(left, top, width, height));
        g2.setStroke(oldStroke);
    }
    
    public void save(java.io.Writer out) throws java.io.IOException {
        out.write("<bar");
        saveRectAttribs(out);
        out.write("frameColor=\"");
        out.write(Utils.colorToStr(frameColor));
        out.write("\" fillColor=\"");
        out.write(Utils.colorToStr(fillColor));
        out.write("\" thickness=\"");
        out.write(Double.toString(thickness));
        out.write("\"/>");
    }
    
}
