/*
 * CompFrame.java
 *
 * Created on 10  2001 ., 19:44
 */

package com.fn.repway;


import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Stroke;
import java.awt.Rectangle;
import org.w3c.dom.Element;


/**
 *
 * @author  asso
 */
public class CompFrame extends Primitive {

    private Color color;
    private double thickness;

    /** Creates a new instance of CompFrame */
    public CompFrame(double x, double y, double width, double height, double thickness,
            Color color) {
        super(x, y, width, height);
        this.color = color;
        this.thickness = thickness;
    }

    public CompFrame(Element tag) throws RepException {
        super(tag);
        color = XMLUtils.getColorAttrib(tag, "color", "#000000");
        thickness = XMLUtils.getAttrib(tag, "thickness", 1.0);
    }
    
    void draw(java.awt.Graphics2D g2) {
        Stroke s = new BasicStroke((float)thickness);
        g2.setColor(color);
        Stroke oldStroke = g2.getStroke();
        g2.setStroke(s);
        g2.draw(new Rectangle.Double(left, top, width, height));
        g2.setStroke(oldStroke);
    }    
    
    public void save(java.io.Writer out) throws java.io.IOException {
        out.write("<frame");
        saveRectAttribs(out);
        out.write("color=\"");
        out.write(Utils.colorToStr(color));
        out.write("\" thickness=\"");
        out.write(Double.toString(thickness));
        out.write("\"/>");
    }
    
}
