/*
 * CompImage.java
 *
 * Created on 11  2001 ., 12:40
 */

package com.fn.repway;


import java.io.OutputStream;
import java.awt.image.BufferedImage;
import javax.imageio.ImageIO;
import org.w3c.dom.Element;


/**
 *
 * @author  asso
 */
public class CompImage extends Primitive {

    private BufferedImage image;
    private String name;
    
    /** Creates a new instance of CompImage */
    public CompImage(double x, double y, double width, double height, 
                BufferedImage image, String name) 
    {
        super(x, y, width, height);
        this.image = image;
        this.name = name;
    }

    public CompImage(GeneratedReport report, Element tag) throws RepException {
        super(tag);
        name = XMLUtils.getData(tag);
        ImageStorage is = (ImageStorage)report.getOffscreen("images");
        image = is.getImage(name);
    }
    
    void draw(java.awt.Graphics2D g2) {
        if (image == null) return;
        double dx=1.0, dy=1.0;
        boolean zoom = false;
        
        java.awt.geom.AffineTransform afft = 
            java.awt.geom.AffineTransform.getTranslateInstance(left, top);
        if (width != image.getWidth()) {
            dx = width / image.getWidth();
            zoom = true;
        }
        if (height != image.getHeight()) {
            dy = height / image.getHeight();
            zoom = true;
        }
        if (zoom)
            afft.scale(dx, dy);
        g2.drawImage(image, afft, null);
    }
    
    public void save(java.io.Writer out) throws java.io.IOException {
        out.write("<image");
        saveRectAttribs(out);
        out.write(">");
        out.write(XMLUtils.escape(name));
        out.write("</image>");
    }
    
}
