/*
 * CompLine.java
 *
 * Created on 2  2001 ., 21:39
 */

package com.fn.repway;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Stroke;
import java.awt.Graphics2D;
import java.awt.geom.Line2D;
import org.w3c.dom.Element;


/**
 *
 * @author  asso
 * @version 
 */
public class CompLine extends Primitive {

    private Color color;
    private double thickness;
    
    /** Creates new CompLine */
    public CompLine(double x, double y, double width, double height, double thickness,
            Color color) {
        super(x, y, width, height);
        this.color = color;
        this.thickness = thickness;
    }

    public CompLine(Element tag) throws RepException {
        super(tag);
        color = XMLUtils.getColorAttrib(tag, "color", "#000000");
        thickness = XMLUtils.getAttrib(tag, "thickness", 1.0);
    }

    void draw(Graphics2D g2) {
        Stroke s = new BasicStroke((float)thickness);
        g2.setColor(color);
        Stroke oldStroke = g2.getStroke();
        g2.setStroke(s);
        g2.draw(new Line2D.Double(left, top, left + width, top + height));
        g2.setStroke(oldStroke);
    }
    
    public void save(java.io.Writer out) throws java.io.IOException {
        out.write("<line");
        saveRectAttribs(out);
        out.write("color=\"");
        out.write(Utils.colorToStr(color));
        out.write("\" thickness=\"");
        out.write(Double.toString(thickness));
        out.write("\"/>");
    }
    
}
