/*
 * LayoutFactory.java
 *
 * Created on 2  2001 ., 9:33
 */

package com.fn.repway;

import org.w3c.dom.Element;

/**
 *
 * @author  asso
 * @version 
 */
public class LayoutFactory {

    static Layout createLayout(Element tag) throws RepException {
        if ((tag == null) || (! tag.getTagName().equals("layout")))
            throw new RepException("Invalid layout tag");

        String type = XMLUtils.getAttrib(tag, "type", "simple");
        if (type.equals("simple"))
            return new SimpleLayout();
        else if (type.equals("columnar"))
            return new ColumnarLayout(tag);
        else
            throw new RepException("Invalid layout type '" + type + "'");
    }

}
