/*
 * Picture.java
 *
 * Created on 10  2001 ., 21:23
 */

package com.fn.repway;


import java.awt.image.BufferedImage;
import java.io.ByteArrayInputStream;
import javax.imageio.ImageIO;
import org.w3c.dom.Element;


/**
 *
 * @author  asso
 */
public class Picture extends RepElement {

    private String name;
    private BufferedImage image;
    
    public Picture(Report report, Element tag) throws RepException {
        super(tag);
        name = XMLUtils.getData(tag);
        try {
            image = ImageIO.read(new ByteArrayInputStream(report.getDataLoader().load(name)));
        } catch (Exception e) {
            throw new RepException("Error loading image: " + e.getMessage());
        }
    }

    public void generate(GenContext ctx, Band band, boolean front) {
        GeneratedReport genRep = ctx.getGenReport();
        ImageStorage is = (ImageStorage)genRep.getOffscreen("images");
        if (is == null) {
            is = new ImageStorage();
            is.addImage(name, image);
            genRep.addOffscreen("images", is);
        } else {
            BufferedImage bi = is.getImage(name);
            if (bi == null)
                is.addImage(name, image);
        }
        band.add(front, new CompImage(left, top, width, height, image, name));
    }
    
}
