/*
 * ReportView.java
 *
 * Created on 22  2003 ., 11:40
 */

package com.fn.repway.designer;


import java.util.Enumeration;
import javax.swing.JScrollPane;

import com.fn.repway.Part;
import com.fn.repway.Report;


/**
 *
 * @author  asso
 */
public class ReportView extends javax.swing.JTabbedPane {
    
    private Report report;
    private Part rootPart;
    
    /** Creates a new instance of ReportView */
    public ReportView() {
        this(new Report());
    }
    
    public ReportView(Report rep) {
        report = rep;
        
        rootPart = new Part(report, "Global");
        rootPart.setPageFooter(report.getPageFooter());
        rootPart.setPageHeader(report.getPageHeader());
        addPart(rootPart);
        
        for (Enumeration enum = rep.getParts(); enum.hasMoreElements(); )
            addPart((Part)enum.nextElement());
        
        setTabPlacement(BOTTOM);
    }
    
    private void addPart(Part part) {
        JScrollPane scrollPane = new JScrollPane(new PartView(part), 
                JScrollPane.VERTICAL_SCROLLBAR_ALWAYS, 
                JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
        add(part.getName(), scrollPane);
    }
}
