/*
 * SectionSeparator.java
 *
 * Created on 22  2003 ., 10:46
 */

package com.fn.repway.designer;


import java.awt.event.MouseEvent;
import javax.swing.border.BevelBorder;


/**
 *
 * @author  asso
 */
public class SectionSeparator implements Draggable {
    
    private int position;
    private BevelBorder border;
    private int dragOrigin;
    
    /** Creates a new instance of SectionSeparator */
    public SectionSeparator(int pos) {
        position = pos;
        border = new BevelBorder(BevelBorder.RAISED);
    }
    
    public void onDragBegin(MouseEvent e) {
        dragOrigin = e.getY() - position;
    }
    
    public void onDragEnd(MouseEvent e) {
    }
    
    public void onDragging(MouseEvent e) {
        position = e.getY() - dragOrigin;
        if (position < 0) 
            position = 0;
    }
    
    public int getPosition() {
        return position;
    }
    
    public int getHeight() {
        return 15;
    }
    
    public void paint(javax.swing.JComponent owner, java.awt.Graphics g) {
        java.awt.Dimension d = owner.getSize();
        border.paintBorder(owner, g, 0, getPosition(), d.width, getHeight());
    }
}
